#ifndef OSSPSFC_H
#define OSSPSFC_H

#include <windows.h>
#include <assert.h>
#include <stdlib.h>

#ifdef __cplusplus 
  extern "C" {
#endif

#ifdef FMQC_VER
  typedef char TCHAR;
#endif

#ifndef MQVAL
#  define MQVAL(x) x
#endif

extern int g_MultiThreadSupport;

typedef __int64 TIMESTRUCT_OS;
typedef HANDLE EVENTOBJ_OS;

void GetTime_OS(TIMESTRUCT_OS* pTS);
double GetElapsedTime_OS(TIMESTRUCT_OS* pStartTime, TIMESTRUCT_OS* pEndTime);
void CreateEvents_OS(void);
void CloseEvents_OS(void);
void Sleep_OS(ULONG ulMilliSeconds);
void SetEvent_OS(EVENTOBJ_OS g_hSync1);
void ResetEvent_OS(EVENTOBJ_OS g_hSync1);
void WaitForEvent_OS(EVENTOBJ_OS hEvent);
LONG InterlockedDecrement_OS(LONG* pDecVar);
LONG InterlockedExchange_OS(LONG* pExchgVar, LONG NewVal);
void StartThreads_OS(void);

#ifdef __cplusplus 
  }
#endif

#endif
